precision mediump float;
varying mediump vec2 textureCoordinate;
uniform sampler2D videoFrame;
uniform sampler2D tex1;
const float textureWidth = 480.0; 
const float textureHeight = 320.0; 
const float blockWidth = 6.0;
const float blockHeight = 6.0;
const float shadesPerChannel = 10.0;
const float dcolor = 1.0 / shadesPerChannel;
const float dcolor2 = dcolor / 2.0;
const float dx = blockWidth * (1.0 / textureWidth);
const float dy = blockHeight * (1.0 / textureHeight);
void main() 
{
	vec3 tc = vec3(1.0, 0.0, 0.0);
	vec2 coord = vec2(dx * floor(textureCoordinate.x / dx), dy * floor(textureCoordinate.y / dy));
	vec4 color = texture2D(videoFrame, coord);
	gl_FragColor = vec4(dcolor * floor((dcolor2 + color.r) / dcolor), dcolor * floor((dcolor2 + color.g) / dcolor), dcolor * floor((dcolor2 + color.b) / dcolor), 1.0);	
}
