varying mediump vec2 textureCoordinate;
uniform sampler2D videoFrame;
highp vec4 edgePath(){
    highp vec4 sample[9];
    highp vec2 tc_offset[9];
    tc_offset[0] = vec2(-1.0/320.0,1.0/480.0);
    tc_offset[1] = vec2(-1.0/320.0,0.0);
    tc_offset[2] = vec2(-1.0/320.0,-1.0/480.0);
    tc_offset[3] = vec2(0.0,1.0/480.0);
    tc_offset[4] = vec2(0.0,0.0);
    tc_offset[5] = vec2(0.0,-1.0/480.0);
    tc_offset[6] = vec2(1.0/320.0,1.0/480.0);
    tc_offset[7] = vec2(1.0/320.0,0.0);
    tc_offset[8] = vec2(1.0/320.0,-1.0/480.0);
    for (int i = 0; i < 9; i++) {
        sample[i] = texture2D(videoFrame, textureCoordinate + tc_offset[i]);
    }
    highp vec4 horizEdge = sample[2] + (2.0*sample[5]) + sample[8] -
    (sample[0] + (2.0*sample[3]) + sample[6]);
    highp vec4 vertEdge = sample[0] + (2.0*sample[1]) + sample[2] -
    (sample[6] + (2.0*sample[7]) + sample[8]);
    highp vec4 fragColor;
    fragColor.rgb = sqrt((horizEdge.rgb * horizEdge.rgb) + 
                         (vertEdge.rgb * vertEdge.rgb));
    fragColor.a = 1.0;
    return fragColor;
}
highp vec4 edge(){
    highp vec2 one = textureCoordinate;
    one.x = one.x+1.0/320.0;
    highp vec2 two = textureCoordinate;
    two.y = two.y+1.0/480.0;
    highp vec4 onet = texture2D(videoFrame, textureCoordinate);
    if(textureCoordinate.x  < 320.0 || textureCoordinate.y < 460.0){
        highp vec4 twot = texture2D(videoFrame, one);
        highp vec4 threet = texture2D(videoFrame, two);
        highp float rr = (onet.r - twot.r)*(onet.r - twot.r) + (onet.r - threet.r)*(onet.r - threet.r);
        highp float gg = (onet.g - twot.g)*(onet.g - twot.g) + (onet.g - threet.g)*(onet.g - threet.g);
        highp float bb = (onet.b - twot.b)*(onet.b - twot.b) + (onet.b - threet.b)*(onet.b - threet.b);
        highp float r = (3.0 * sqrt(rr));
        highp float g = (3.0 * sqrt(gg));
        highp float b = (3.0 * sqrt(bb));
        if(r < 0.0){
            r = 0.0;
        }else{
            r = r;
        }
        if(r > 1.0){
            r = 1.0;
        }else{
            r = r ;
        }
        if(g < 0.0){
            g = 0.0;
        }else{
            g = g;
        }
        if(g > 1.0){
            g = 1.0;
        }else{
            g = g ;
        }
        if(b < 0.0){
            b = 0.0;
        }else{
            b = b;
        }
        if(b > 1.0){
            b = 1.0;
        }else{
            b = b;
        }
        return vec4(r,g,b,1.0);
    }
    return onet;
}
void main()
{
    gl_FragColor = edgePath();
}
