precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D videoFrame;
uniform sampler2D s_contrastMap;
uniform sampler2D s_overlayMap;
uniform sampler2D s_noiseMap;
uniform vec2 randomCoord1;
uniform vec2 randomCoord2;
uniform float frameCounter;
const float noiseFactor = 0.05;
const float scratchFactor = 0.0044;

const float scratchFactorInverse = 1.0 / scratchFactor;
const vec3 lumcoeff = vec3(0.299, 0.587, 0.114);
const vec3 sepiatone = vec3(0.9, 0.8, 0.6);

void main()
{
	vec4 color = texture2D(videoFrame, textureCoordinate);
	float gray = dot(color.rgb, lumcoeff);
	color = vec4(gray * sepiatone, 1.0);
	vec2 dist = 0.5 - textureCoordinate;
	float fluc = randomCoord2.x * 0.04 - 0.02;
	color.rgb *= (0.4 + fluc - dot(dist, dist))  * 2.8;
	gl_FragColor = color;
}
